' --------------------------------------------------
' Maxwell Vbs created by PExprt(TM) Release 2021 R1
'  2021 UPM-SAS IP, Inc.
' --------------------------------------------------
Dim oAnsoftApp
Dim oDesktop
Dim oProject
Dim oDesign
Dim oEditor
Dim oModule
Dim f, frq(13)
Dim w1, w2
Dim vol(2)
Set oAnsoftApp = CreateObject("Ansoft.ElectronicsDesktop.2021.1")
Set oDesktop = oAnsoftApp.GetAppDesktop()
Set oProject = oDesktop.SetActiveProject("Flyback_PAR")
Set oDesign = oProject.SetActiveDesign("SourceForMesh")
Set oModule = oDesign.GetModule("FieldsReporter")

frq(0) = 1.0
frq(1) = 10000.0
frq(2) = 17782.8
frq(3) = 31622.8
frq(4) = 56234.1
frq(5) = 100000.0
frq(6) = 177827.9
frq(7) = 316227.8
frq(8) = 562341.3
frq(9) = 1000000.0
frq(10) = 1778279.4
frq(11) = 3162277.7
frq(12) = 5623413.3
frq(13) = 10000000.0

For f = 0 To 13
  For w1 = 0 To 3
    oModule.CalculatorRead "J" + CStr(w1 + 1) + "_" + CStr(f + 1) + ".reg", _
      "Mesh : LastAdaptive", "Fields", _
      Array("Freq:=", "10.0MHz", _
        "Ipeak1:=", "1A", _
        "Ipeak2:=", "1A", _
        "Ipeak3:=", "1A", _
        "Ipeak4:=", "1A", _
        "Phase:=", "0deg")
    oModule.CalcStack "push"
    For w2 = w1 To 3
      oModule.CalcStack "push"
      If w1 <> w2 Then
        oModule.CalculatorRead "J" + CStr(w2 + 1) + "_" + CStr(f + 1) + ".reg", _
          "Mesh : LastAdaptive", "Fields", _
          Array("Freq:=", "10.0MHz", _
            "Ipeak1:=", "1A", _
            "Ipeak2:=", "1A", _
            "Ipeak3:=", "1A", _
            "Ipeak4:=", "1A", _
            "Phase:=", "0deg")
      End If
      oModule.ClcMaterial "Conductivity (cond)", "div"
      oModule.CalcOp "Conj"
      oModule.CalcOp "Dot"
      oModule.CalcOp "Real"
      oModule.EnterVol "Windings"
      oModule.CalcOp "RZIntegrate"
      oModule.ClcEval "Mesh : LastAdaptive", _
        Array("Freq:=", "10.0MHz", _
          "Ipeak1:=", "1A", _
          "Ipeak2:=", "1A", _
          "Ipeak3:=", "1A", _
          "Ipeak4:=", "1A", _
          "Phase:=", "0deg")
      oModule.CalculatorWrite "R" + CStr(w1 + 1) + "_" + CStr(w2 + 1) + "_" + CStr(f + 1) + ".reg", _
        Array("Solution:=", "Mesh : LastAdaptive"), _
        Array("Freq:=", "10.0MHz", _
          "Ipeak1:=", "1A", _
          "Ipeak2:=", "1A", _
          "Ipeak3:=", "1A", _
          "Ipeak4:=", "1A", _
          "Phase:=", "0deg")
      oModule.CalcStack "pop"
      oModule.CalcStack "pop"
    Next
    oModule.CalcStack "clear"
  Next
Next

For f = 0 To 13
  For w1 = 0 To 3
    oModule.CalculatorRead "H" + CStr(w1 + 1) + "_" + CStr(f + 1) + ".reg", _
      "Mesh : LastAdaptive", "Fields", _
      Array("Freq:=", "10.0MHz", _
        "Ipeak1:=", "1A", _
        "Ipeak2:=", "1A", _
        "Ipeak3:=", "1A", _
        "Ipeak4:=", "1A", _
        "Phase:=", "0deg")
    oModule.CalcStack "push"
    For w2 = w1 To 3
      oModule.CalcStack "push"
      If w1 <> w2 Then
        oModule.CalculatorRead "H" + CStr(w2 + 1) + "_" + CStr(f + 1) + ".reg", _
          "Mesh : LastAdaptive", "Fields", _
          Array("Freq:=", "10.0MHz", _
            "Ipeak1:=", "1A", _
            "Ipeak2:=", "1A", _
            "Ipeak3:=", "1A", _
            "Ipeak4:=", "1A", _
            "Phase:=", "0deg")
      End If
      oModule.ClcMaterial "Permeability (mu)", "mult"
      oModule.CalcOp "Conj"
      oModule.CalcOp "Dot"
      oModule.CalcOp "Real"
      oModule.EnterVol "NoCoreGap"
      oModule.CalcOp "RZIntegrate"
      oModule.ClcEval "Mesh : LastAdaptive", _
        Array("Freq:=", "10.0MHz", _
          "Ipeak1:=", "1A", _
          "Ipeak2:=", "1A", _
          "Ipeak3:=", "1A", _
          "Ipeak4:=", "1A", _
          "Phase:=", "0deg")
      oModule.CalcStack "exch"
      oModule.CalcStack "undo"
      oModule.CalcStack "undo"
      oModule.CalcStack "pop"
      oModule.EnterVol "background"
      oModule.CalcOp "RZIntegrate"
      oModule.ClcEval "Mesh : LastAdaptive", _
        Array("Freq:=", "10.0MHz", _
          "Ipeak1:=", "1A", _
          "Ipeak2:=", "1A", _
          "Ipeak3:=", "1A", _
          "Ipeak4:=", "1A", _
          "Phase:=", "0deg")
      oModule.CalcStack "exch"
      oModule.CalcStack "pop"
      oModule.CalcOp "+"
      oModule.EnterScalar frq(f)
      If w1 = 0 And w2 = 0 Then
        oModule.CalculatorWrite "F_" + CStr(f + 1) + ".reg", _
          Array("Solution:=", "Mesh : LastAdaptive"), _
          Array("Freq:=", "10.0MHz", _
            "Ipeak1:=", "1A", _
            "Ipeak2:=", "1A", _
            "Ipeak3:=", "1A", _
            "Ipeak4:=", "1A", _
            "Phase:=", "0deg")
      End If
      oModule.CalcOp "*"
      oModule.EnterScalar 6.283185
      oModule.CalcOp "*"
      oModule.CalculatorWrite "X" + CStr(w1 + 1) + "_" + CStr(w2 + 1) + "_" + CStr(f + 1) + ".reg", _
        Array("Solution:=", "Mesh : LastAdaptive"), _
        Array("Freq:=", "10.0MHz", _
          "Ipeak1:=", "1A", _
          "Ipeak2:=", "1A", _
          "Ipeak3:=", "1A", _
          "Ipeak4:=", "1A", _
          "Phase:=", "0deg")
      oModule.CalcStack "pop"
    Next
    oModule.CalcStack "clear"
  Next
Next

vol(0) = "Core"
vol(1) = "GapI"
vol(2) = "GapE"

For i = 0 To 2
  oModule.CalculatorRead "H1_1.reg", _
    "Mesh : LastAdaptive", "Fields", _
    Array("Freq:=", "10.0MHz", _
      "Ipeak1:=", "1A", _
      "Ipeak2:=", "1A", _
      "Ipeak3:=", "1A", _
      "Ipeak4:=", "1A", _
      "Phase:=", "0deg")
  oModule.CalcStack "push"
  oModule.ClcMaterial "Permeability (mu)", "mult"
  oModule.CalcOp "Conj"
  oModule.CalcOp "Dot"
  oModule.CalcOp "Real"
  oModule.EnterVol vol(i)
  oModule.CalcOp "RZIntegrate"
  oModule.ClcEval "Mesh : LastAdaptive", _
    Array("Freq:=", "10.0MHz", _
      "Ipeak1:=", "1A", _
      "Ipeak2:=", "1A", _
      "Ipeak3:=", "1A", _
      "Ipeak4:=", "1A", _
      "Phase:=", "0deg")
  oModule.CalculatorWrite vol(i) + ".reg", _
    Array("Solution:=", "Mesh : LastAdaptive"), _
    Array("Freq:=", "10.0MHz", _
      "Ipeak1:=", "1A", _
      "Ipeak2:=", "1A", _
      "Ipeak3:=", "1A", _
      "Ipeak4:=", "1A", _
      "Phase:=", "0deg")
  oModule.CalcStack "clear"
Next

Set oDesign = oProject.SetActiveDesign("SourceForMesh")
oDesign.ExportConvergence "Mesh", "", "..\SourceForMesh.cnv"
